summaryrefslogtreecommitdiff
path: root/extra
diff options
context:
space:
mode:
authorGabriel F. T. Gomes <gabriel@inconstante.net.br>2019-08-07 09:17:13 -0300
committerGabriel F. T. Gomes <gabriel@inconstante.net.br>2019-08-07 09:17:13 -0300
commit5732da2af736c40cf693354485446ab4867ecb4d (patch)
tree76d76cdfa16ca62d20fb109da13895ec64fff110 /extra
parent9cd22d1df8f0f5b554858471c86faa9f37b8fed4 (diff)
downloadbash-completion-5732da2af736c40cf693354485446ab4867ecb4d.tar.gz
New upstream version 2.9upstream/2.9
Diffstat (limited to 'extra')
-rwxr-xr-xextra/git-post-commit.sh23
-rwxr-xr-xextra/git-pre-push.sh41
2 files changed, 64 insertions, 0 deletions
diff --git a/extra/git-post-commit.sh b/extra/git-post-commit.sh
new file mode 100755
index 00000000..18238585
--- /dev/null
+++ b/extra/git-post-commit.sh
@@ -0,0 +1,23 @@
+#!/bin/sh -e
+
+# Post-commit hook for triggering bash-completion Docker Hub test image
+# builds at https://hub.docker.com/r/vskytta/bash-completion/
+#
+# To enable: ln -s ../../extra/git-post-commit.sh .git/hooks/post-commit
+#
+# The bash-completion.docker-hub-trigger-url config option must be set to
+# the full Docker Hub build trigger URL to hit.
+
+url=$(git config bash-completion.docker-hub-trigger-url)
+
+test "$(git symbolic-ref --short HEAD 2>/dev/null)" = master
+
+git diff-tree -r --name-only --no-commit-id HEAD | \
+ grep -qxE 'completions/Makefile\.am|test/requirements\.txt'
+
+curl \
+ --silent --show-error \
+ --max-time 30 \
+ --header Content-Type:application/json \
+ --data '{"build":true}' \
+ $url >/dev/null
diff --git a/extra/git-pre-push.sh b/extra/git-pre-push.sh
new file mode 100755
index 00000000..27de6013
--- /dev/null
+++ b/extra/git-pre-push.sh
@@ -0,0 +1,41 @@
+#!/bin/sh -e
+
+# Pre-push hook for triggering bash-completion Docker Hub test image
+# builds at https://hub.docker.com/r/vskytta/bash-completion/
+#
+# To enable: ln -s ../../extra/git-pre-push.sh .git/hooks/pre-push
+#
+# The bash-completion.docker-hub-trigger-url config option must be set to
+# the full Docker Hub build trigger URL to hit.
+
+url=$(git config bash-completion.docker-hub-trigger-url) || exit 0
+
+branch=master
+files="completions/Makefile\.am|test/requirements\.txt"
+
+trigger=false
+z40=0000000000000000000000000000000000000000
+
+while read local_ref local_sha remote_ref remote_sha; do
+ case $remote_ref in */$branch) ;; *) continue ;; esac
+ [ $local_sha != $z40 ] || continue # delete not handled (yet?)
+ if [ $remote_sha = $z40 ]; then
+ list_files="git ls-tree -r --name-only $local_sha"
+ else
+ list_files="git diff --name-only $remote_sha..$local_sha"
+ fi
+ ! $list_files | grep -qEx $files || { trigger=true; break; }
+done
+
+if $trigger; then
+ cat <<EOF | at -M now
+ sleep 15
+ curl \
+ --silent --show-error \
+ --max-time 30 \
+ --header Content-Type:application/json \
+ --data '{"build":true}' \
+ $url 2>&1 \
+ | logger -e --tag bash-completion-pre-push
+EOF
+fi